<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category template manager
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 26, 2013 11:36:11 AM
 * @version $Rev$
 */

/**
 * Settings class
 * Used to generate an WP administration tab to view a list of cx shortcodes
 */
class Admin_Help_Shortcodes extends WP_Page {

    protected $interfacer = null;

    public function __construct() {
        $this->interfacer = WP_Interfacer::getInstance();
    }

    public function getCapability() {
        return WP_Constants::CAPABILITY_ADMIN;
    }

    public function getMenuSlug() {
        return 'carerix_shortcodes_page';
    }

    public function getMenuTitle() {
        return 'Shortcodes';
    }

    public function getPageTitle() {
        return 'Shortcodes';
    }

    public function page() {
        $this->listShortcodes();
    }

    private function listShortcodes() {
	    $jobFrontend = new Frontend_Shortcode_Job();
	    $shortcodes = $jobFrontend->register_shortcodes()->getAll();

        $data = array(
            'shortcodes' => $shortcodes,
        );

        $template = new Utils_Template('admin/help/shortcodes');
        $template->with($data)->display();
    }

    private function createActionLink($action_name) {
        return 'admin.php?page=' . $this->getParentTab()->getMenuSlug() .
                '&tab=' . $this->getMenuSlug() .
                '&action=' . $action_name;
    }

}