<?php

use Carerix\Api\Rest\Entity\CRWorkHistory;

class Entity_Carerix_EmployeeSkill {

    private $postValues = array();
    private $employeeSkill = null;
    private static $count = 0;
    
    private $values = array(
        'skill' => '',
        'skill_1' => '',
        'skill_2' => '',
    );

    public function __construct($values, $employee) {
        $this->postValues = $values;
        $this->employeeSkill = $employee;
    }
    
    public function getData() {
        /**
         * empty data
         */
        if(count($this->postValues) <= 0 && $this->employeeSkill === null) {
            self::$count++;
            return $this->values;
        }
        
        /**
         * there are some post data. Post data has priority over carerix data
         */
        if(count($this->postValues) > 0) {
            
            foreach($this->values as $fieldName => &$value) {
                if(   isset($this->postValues[$fieldName])
                   && isset($this->postValues[$fieldName][self::$count])) {
                    $value = $this->postValues[$fieldName][self::$count];
                }
            }
            
            self::$count++;
            return $this->values;
        }
        
        /**
         * if it reached this point, there are no post data, carerix data has 
         * priority
         */
        if(   $this->employeeSkill !== null 
           && isset($this->employeeSkill[self::$count])) {
            
            /** @var CRWorkHistory ToDo */
            $skill = $this->employeeSkill[self::$count];
            foreach($this->values as $fieldName => &$value) {
                switch($fieldName) {
                    case 'skill':
                        $node = $skill->getToSkillLevel1();
                        $value = '';
                        if($node) {
                            $value = $skill->getToSkillLevel1()->getId();   
                        }
                        break;
                    case 'skill_1':
                        $node = $skill->getToSkillLevel2();
                        $value = '';
                        if($node) {
                            $value = $skill->getToSkillLevel2()->getId();   
                        }
                    break;
                    case 'skill_2':
                        $node = $skill->getToSkillLevel3();
                        $value = '';
                        if($node) {
                            $value = $skill->getToSkillLevel3()->getId();   
                        }
                    break;
                    default:
                        $methodName = 'get'.ucfirst($fieldName);
                        $value = $skill->$methodName();
                        break;
                }
            }
            
            self::$count++;
            return $this->values;
        }
    }
}